import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "!WQVQPOOOhQPO'#CdOOQO'#Ci'#CiOOQO'#Ce'#CeQVQPOOOOQO,59O,59OOoQPO,59OOOQO-E6c-E6cOOQO1G.j1G.j",
  stateData: "v~O[OS~OQQORQOSQOTQOVPO~OUTO~PVOUWO~PVO",
  goto: "u^PPPPPPPP_ePPPoXQOPSUQSOQUPTVSUXROPSU",
  nodeNames: "⚠ Program CompareOp Keyword String Number ) ( Application",
  maxTerm: 13,
  nodeProps: [
    ["openedBy", 6,"("],
    ["closedBy", 7,")"]
  ],
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "&e~ReX^!dpq!drs#Xxy$uyz$z{|%P}!O%P!Q!R%Y!R![%k!^!_%s!_!`&O!`!a&T!c!}&]#y#z!d$f$g!d#BY#BZ!d$IS$I_!d$I|$JO!d$JT$JU!d$KV$KW!d&FU&FV!d~!iY[~X^!dpq!d#y#z!d$f$g!d#BY#BZ!d$IS$I_!d$I|$JO!d$JT$JU!d$KV$KW!d&FU&FV!d~#[VOr#Xrs#qs#O#X#O#P#v#P;'S#X;'S;=`$o<%lO#X~#vOS~~#yRO;'S#X;'S;=`$S;=`O#X~$VWOr#Xrs#qs#O#X#O#P#v#P;'S#X;'S;=`$o;=`<%l#X<%lO#X~$rP;=`<%l#X~$zOV~~%POU~~%SQ!Q!R%Y!R![%k~%_QT~!O!P%e!Q![%k~%hP!Q![%k~%pPT~!Q![%k~%xQQ~!_!`&O!`!a&O~&TOQ~~&YPQ~!_!`&O~&bPR~!c!}&]",
  tokenizers: [0],
  topRules: {"Program":[0,1]},
  tokenPrec: 0
});

const NuformulaLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                Keyword: tags.keyword,
                String: tags.string,
                Number: tags.number,
                CompareOp: tags.compareOperator,
                "( )": tags.paren,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: ";" },
    },
});
function nuformula() {
    return new LanguageSupport(NuformulaLanguage);
}

export { NuformulaLanguage, nuformula };
